%define name xparam
%define major 1
%define libname %mklibname %name %major

Summary: XParam is a general-purpose library for parameter handling in C++
Name: xparam
Version: 1.22
Release: 1mdk
License: GPL
Group: System/Libraries
URL: http://xparam.sourceforge.net/
Source: http://prdownloads.sourceforge.net/xparam/%{name}-%{version}.tar.bz2
BuildRoot: %_tmppath/%name-%version-root

%description
XParam is an extensible, type-safe, non-intrusive, object-oriented tool
for general-purpose object serialization and deserialization in C++, good
for parsing command-line parameters and cross-program/cross-platform
communication. It can handle named parameters as well as object streams. It
recognizes class hierarchies, abstract interfaces, and polymorphism, and can
therefore serve as a plug-in management framework (e.g., for strategy
management).

%package -n %libname
Summary: XParam is a general-purpose library for parameter handling in C++
Group: System/Libraries
Requires: %name-plugins >= %version-%release

%description -n %libname
XParam is an extensible, type-safe, non-intrusive, object-oriented tool
for general-purpose object serialization and deserialization in C++, good
for parsing command-line parameters and cross-program/cross-platform
communication. It can handle named parameters as well as object streams. It
recognizes class hierarchies, abstract interfaces, and polymorphism, and can
therefore serve as a plug-in management framework (e.g., for strategy
management).

%package -n %libname-devel
Summary: XParam is a general-purpose librariy for parameter handling in C++
Group: Development/C++
Requires: %{libname} = %{version}-%{release}
Provides: %{name}-devel = %{version}-{%release}
Provides: lib%{name}-devel = %{version}-{%release}

%description  -n %libname-devel
XParam is an extensible, type-safe, non-intrusive, object-oriented tool
for general-purpose object serialization and deserialization in C++, good
for parsing command-line parameters and cross-program/cross-platform
communication. It can handle named parameters as well as object streams. It
recognizes class hierarchies, abstract interfaces, and polymorphism, and can
therefore serve as a plug-in management framework (e.g., for strategy
management).

You need the development RPM in order to develop programs that use the XParam
library.

%package plugins
Summary: Configuration for XParam
Group: System/Libraries

%description plugins
XParam is an extensible, type-safe, non-intrusive, object-oriented tool
for general-purpose object serialization and deserialization in C++, good
for parsing command-line parameters and cross-program/cross-platform
communication. It can handle named parameters as well as object streams. It
recognizes class hierarchies, abstract interfaces, and polymorphism, and can
therefore serve as a plug-in management framework (e.g., for strategy
management).

This contains the nessessary configuration to support XParam plugins.

%prep
%setup -q %{name}-%{version}
tar czf doc/examples.tar.gz examples

%build
%configure --disable-config-examples
%make
cat - << EOF > doc/README.Package
The "XPARAM_CLASSPATH" has been pointed at %_libdir/%{name}-plugins.
EOF

%install
%makeinstall_std
install -d $RPM_BUILD_ROOT/%_libdir/%{name}-plugins
install -d $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
install contrib/25xparam.sh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
install contrib/25xparam.csh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
DESTDIR=$RPM_BUILD_ROOT make check

%post -n %libname -p /sbin/ldconfig
%postun -n %libname -p /sbin/ldconfig

%post -n %libname-devel
/sbin/install-info --entry="`cat %_datadir/doc/%{libname}-devel-%{version}/infodescription`" \
	--section="Programming & development tools." \
	%{_infodir}/%{name}.info %{_infodir}/dir

%preun -n %libname-devel
if [ "$1" = 0 ]; then
	/sbin/install-info --remove \
		--entry="`cat %_datadir/doc/%{libname}-devel-%{version}/infodescription`" \
		--section="Programming & development tools." \
		%{_infodir}/%{name}.info %{_infodir}/dir
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files plugins
%defattr(-,root,root)
%doc AUTHORS BUGS ChangeLog README TODO
%dir %_libdir/%{name}-plugins
%config(noreplace) %{_sysconfdir}/profile.d/*

%files -n %libname
%defattr(-,root,root)
%_libdir/*.so.*

%files -n %libname-devel
%defattr(-,root,root)
%doc doc/*.html doc/infodescription doc/doc_examples doc/xparam.sgml
%_libdir/*.a
%_libdir/*.la
%_libdir/*.so
%_includedir/*
%_infodir/%{name}*

%changelog
* Sat May  1 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.22-1mdk
- initial mdk package

* Sat Nov 15 2002 Shachar Shemesh <xparamrpm@sun.consumer.org.il>
- Initial version

